import { world, system } from "@minecraft/server";

const no = world.scoreboard.getObjective("no") ?? world.scoreboard.addObjective("no","NO")
const no_off = world.scoreboard.getObjective("no_off") ?? world.scoreboard.addObjective("no_off","NO_OFF")
const level1 = world.scoreboard.getObjective("level1") ?? world.scoreboard.addObjective("level1","LEVEL1")

system.runInterval(() => {
    for (const player of world.getAllPlayers()) {
    const scoresNo = no.getScore(player);
    const scoresNo_off = no_off.getScore(player);
    const scoresLevel1 = level1.getScore(player);
    const { x, y, z } = player.getViewDirection();
        if (player.hasTag("wither")){
            player.runCommandAsync(`execute at @s[tag=wither] run particle minecraft:end_chest ~~~`);
            player.runCommandAsync(`execute as @s[tag=wither] at @s run effect @e[family=!despawncito,tag=!wither,r=7] wither 1 255 true`);
            player.runCommandAsync(`execute as @s[family=!despawncito,tag=wither] at @s run execute as @e[tag=!wither,r=7] at @s run particle minecraft:end_chest ~~~`);
            system.runTimeout(() => {
                player.runCommandAsync(`execute as @s[family=!despawncito,tag=wither] at @s run execute as @e[family=!despawncito,tag=!wither,r=7] at @s run summon tunekeshi:battou_3`);
        }, 24)
            system.runTimeout(() => {
                player.runCommandAsync(`execute as @s[family=!despawncito,tag=wither] at @s run execute as @e[family=!despawncito,tag=!wither,r=7] at @s run summon tunekeshi:battou_3`);
        }, 49)
            system.runTimeout(() => {
                player.runCommandAsync(`execute as @s[family=!despawncito,tag=wither] at @s run execute as @e[family=!despawncito,tag=!wither,r=7] at @s run summon tunekeshi:battou_3`);
        }, 74)
            system.runTimeout(() => {
                player.runCommandAsync(`execute as @s[family=!despawncito,tag=wither] at @s run execute as @e[family=!despawncito,tag=!wither,r=7] at @s run summon tunekeshi:battou_3`);
        }, 99)
        system.runTimeout(() => {
            player.removeTag("wither");
        }, 100);}
        if (!player.hasTag("knockback") && player.hasTag("hand") && player.isSneaking && player.isJumping){
            player.applyKnockback(x, z, 2, y *0.1);
            player.addTag("knockback");
            player.runCommandAsync(`execute at @s[tag=knockback] run particle minecraft:huge_explosion_emitter ^^^-1`);
            player.runCommandAsync(`execute at @s[tag=knockback] run damage @e[r=2,tag=!knockback] 3`);
            system.runTimeout(() => {
            player.removeTag("knockback");
        }, 10);}
        if (scoresNo >= 60){
            system.runTimeout(() => {
            player.runCommandAsync(`scoreboard players remove @s[scores={level1=1..}] level1 1`);
        },20);}
        if (scoresNo >= 180){
            player.runCommandAsync(`scoreboard players set @s[scores={no=180..}] no 180`);
            player.runCommandAsync(`scoreboard players set @s[scores={no=180..}] level1 0`);
            player.runCommandAsync(`event entity @s[scores={no=180..}] normal`);
        }
        if (scoresNo_off >= 180){
            player.runCommandAsync(`scoreboard players set @s[scores={no_off=180..}] no_off 180`);
        }
//DからC
        if (scoresLevel1 >= 1 && scoresLevel1 <= 5){
            player.runCommandAsync(`event entity @s lvl1`);
        }
//BからA
        if (scoresLevel1 >= 6 && scoresLevel1 <= 14){
            player.runCommandAsync(`event entity @s lvl2`);
        }
//SからSS
        if (scoresLevel1 >= 15 && scoresLevel1 <= 27){
            player.runCommandAsync(`event entity @s lvl3`);
        }
//SSS
        if (scoresLevel1 >= 28){
            player.runCommandAsync(`event entity @s lvl4`);
            player.runCommandAsync(`scoreboard players set @s[scores={level1=28..}] level1 28`);
        }
        if (player.hasTag("hand")){
        player.runCommandAsync(`execute as @a if entity @s[hasitem=[{location=slot.weapon.mainhand,item=tunekeshi:b1,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b2,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b3,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b4,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b5,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b6,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b7,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b8,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b9,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b10,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b11,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b12,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b13,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b14,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b15,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b16,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b17,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b18,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b19,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b20,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b21,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b22,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b23,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b24,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b25,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b26,quantity=0}, {location=slot.weapon.mainhand,item=tunekeshi:b27,quantity=0}, {location=slot.weapon.mainhand,item=tunekeshi:b28,quantity=0}]] run tag @s remove hand`);
        }
    player.runCommandAsync(`function level1`);
    no.addScore(player,1)
    no_off.addScore(player,1)
    player.runCommandAsync(`event entity @s[scores={level1=..0}] normal`);
    player.runCommandAsync(`execute as @a unless entity @s[hasitem=[{location=slot.weapon.mainhand,item=tunekeshi:b1,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b2,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b3,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b4,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b5,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b6,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b7,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b8,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b9,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b10,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b11,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b12,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b13,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b14,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b15,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b16,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b17,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b18,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b19,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b20,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b21,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b22,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b23,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b24,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b25,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b26,quantity=0},{location=slot.weapon.mainhand,item=tunekeshi:b27,quantity=0}, {location=slot.weapon.mainhand,item=tunekeshi:b28,quantity=0}]] run tag @s add hand`);

}});

//killcount

world.afterEvents.entityDie.subscribe((data) => {
    let { damageSource, deadEntity } = data;
    let damagingEntity = damageSource?.damagingEntity;
    if (!damagingEntity) return;
    if (damagingEntity.typeId === "minecraft:player" || damagingEntity.typeId === "tunekeshi:battou_3") {
        if (damagingEntity.typeId === "minecraft:player") {
            let equippable = damagingEntity.getComponent("minecraft:equippable");
            let holdItem = equippable.getEquipment("Mainhand");
            if (holdItem && holdItem.typeId.startsWith("tunekeshi:b")) {
                let lore = holdItem.getLore();
                if (lore[0]?.startsWith("§r§4KillCount : ")) {
                    let number = Number(lore[0].slice(16)) + 1;
                    holdItem.setLore([`§r§4KillCount : ${number}`]);
                } else {
                    holdItem.setLore(['§r§4KillCount : 1']);
                }
                equippable.getEquipmentSlot("Mainhand").setItem(holdItem);
            }
        }
    }
});