import { world, system } from "@minecraft/server";

system.runInterval(() => {
    for (const entity of world.getDimension("overworld").getEntities()) {
        if (entity.typeId === "minecraft:item") {
            const item = entity.getComponent("item").itemStack;
            const itemType = item.typeId;
            for (let i = 1; i <= 26; i++) {
                if (itemType === `tunekeshi:b${i}`) {
                    entity.addTag(`b${i}`);
                    break;
                }
            }
        }
    }
});